#include<stdio.h>
#include<stdlib.h>
#include<time.h>

struct tnode
{
    struct tnode *parent;
	int key_value;
    struct tnode *left;
    struct tnode *right;
};


int Compare_Key(int , int );
int Find(tnode* ,int );
void destroy_tree(tnode *);
struct tnode*  insert(int ,tnode *);


int main()
{
	int i,counter,element,sec,*el=0;
	struct tnode *btree;
	printf("Give the number of the elements,\nthat you want to have your b-tree\n");
	scanf("%d",&counter);
	btree=NULL;
	for(i=0;i<counter;i++)
	{
		element=rand();
		btree=insert(element,btree);
	}
	printf("Give the number of the elements,\nthat you want to be accessed to your b-tree\n");
	scanf("%d",&counter);
	el=(int*)malloc(counter*sizeof(int));
	for(i=0;i<counter;i++)
	{
		*(el+i)=rand();		
	}
	sec=time(0);
	for(i=0;i<counter;i++)
	{
		Find(btree,*(el+i));		
	}
	printf("\ntime of execution of Find=%3d\n",(time(0)-sec));
	destroy_tree(btree);
	return 0;
}




/*h sinartisi afti vriskei an iparxei to k sto dentro kai
an nai epistrefei afto allios petaei analogo minima*/ 
int Find(tnode *tree ,int k)
{
	int find=0;
	do{
		if (tree->key_value == k) {
			find=1;
		}
		else if(tree->key_value < k){
			tree=tree->right;
		}
		else if(tree->key_value > k){
			tree=tree->left;
		}
	}while(tree!=NULL && find!=1);
	if(find==1){
		return k;
	}
    else {
        printf("That doesn't exist\n");
		return -1;
    }
}

//diagrafei to dentro
void destroy_tree(tnode *leaf)
{
  if(leaf!=NULL)
  {
    destroy_tree(leaf->left);
    destroy_tree(leaf->right);
    delete leaf;
  }
}

//prosthetei neo komvo sto b-tree 
struct tnode * insert(int element,tnode *leaf)
{
	if(leaf!=NULL)
	{
		if(element< leaf->key_value)
		{
            if(leaf->left!=NULL)
				insert(element, leaf->left);
            else
			{
				leaf->left=new tnode;
                leaf->left->key_value=element;
	            leaf->left->parent=leaf;
                leaf->left->left=NULL;   
                leaf->left->right=NULL;  
			}
		}
		else if(element>=leaf->key_value)
		{
            if(leaf->right!=NULL)
				insert(element, leaf->right);
            else
			{
				leaf->right=new tnode;
                leaf->right->key_value=element;
	            leaf->right->parent=leaf;
                leaf->right->left=NULL;  
                leaf->right->right=NULL; 
			}
		}
	}
    else
	{
		leaf=new tnode;
        leaf->key_value=element;
        leaf->left=NULL;
        leaf->right=NULL;
	}
    return leaf;
}
